unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, Grids,
  ShellAPI, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FileListBox1: TFileListBox;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    Label3: TLabel;
    Button1: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    RichEdit1: TRichEdit;
    Label4: TLabel;
    Edit1: TEdit;
    Button5: TButton;
    Label5: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  DirectoryListBox1.Directory:='C:\';

  Edit1.Text:= '*.asp';
  Edit2.Clear;
  Edit3.Clear;
  Edit4.Clear;
  Edit5.Clear;

  Button2.Visible:=False;
  Button3.Visible:=False;
  Button4.Visible:=False;

  ListBox1.Clear;
  ListBox2.Clear;

  RichEdit1.Clear;
  RichEdit1.PlainText:=True;

end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i,X, ToEnd : integer;
  Change: Boolean;
  OldDir: String;
begin

  Edit4.Text := DateTimeToStr(Now);

  ListBox1.Clear;
  ListBox2.Clear;
  OldDir:=DirectoryListBox1.Directory;
  ListBox2.AddItem(DirectoryListBox1.Directory , nil );

  i:=0;
  while i < ListBox2.Count do
  begin
    DirectoryListBox1.Directory:=ListBox2.Items[i];
    Button4.Click;
    i:=i+1;
//    ListBox2.Items.Delete(0);
  end;

  for i:=0 to ListBox2.Count-1 do
  begin
    DirectoryListBox1.Directory:=ListBox2.Items[i];
    Button2.Click;
  end;

  Form1.Repaint;

  for i:=0 to ListBox1.Count-1 do
  begin
    RichEdit1.Lines.LoadFromFile(ListBox1.Items[i]);
    Change:=False;
    with RichEdit1 do
    begin
      X := 0;
      ToEnd := length(Text) ;
      X := FindText(Edit2.Text, X, ToEnd, []) ;
      while X <> -1 do
      begin
        SetFocus;
        SelStart := X;
        SelLength := length(Edit2.Text);
        SelText := Edit3.Text;
        X := FindText(Edit2.Text,X + length(Edit3.Text),ToEnd, []) ;
        Change:=True;
      end;
      if Change then
        RichEdit1.Lines.SaveToFile(ListBox1.Items[i]);
    end;
  end;

  Edit5.Text := DateTimeToStr(Now);  
  DirectoryListBox1.Directory := OldDir;
  ShowMessage('Find and Replace Finish !');

end;

procedure TForm1.Button2Click(Sender: TObject);
var
  sr: TSearchRec;
  FileAttrs: Integer;
  X, ToEnd : integer;

begin
  FileAttrs := faArchive;
  if FindFirst(Edit1.Text, FileAttrs, sr) = 0 then
  begin
    repeat
      if (sr.Attr and FileAttrs) = sr.Attr then
      begin
        ListBox1.AddItem(DirectoryListBox1.Directory + '\'+ sr.Name, nil );
      end;
    until FindNext(sr) <> 0;
    FindClose(sr);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ListBox1.Clear;
  ListBox2.Clear;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  sr2: TSearchRec;
  FileAttrs: Integer;
begin

  FileAttrs := faDirectory;
  if FindFirst('*.*', FileAttrs, sr2) = 0 then
  begin
    repeat
      if (sr2.Attr and FileAttrs) = faDirectory then
      begin
        if (sr2.Name<>'.') and (sr2.Name<>'..') then
        begin
          ListBox2.AddItem(DirectoryListBox1.Directory + '\'+ sr2.Name, nil );
        end;
      end;
    until FindNext(sr2) <> 0;
    FindClose(sr2);
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Application.Terminate;
end;

end.
